
<p>Na prethodnoj stranici razmatrali smo sklop koji ostvaruje logičku funkciju čija je tablica istinitosti prikazana u nastavku.</p>

<table class="mlTableCC mlTableVR2">
<thead>
<tr><th>A</th><th>B</th><th>f</th></tr>
</thead>
<tbody>
<tr><td><code>0</code></td><td><code>0</code></td><td><code>0</code></td></tr>
<tr><td><code>0</code></td><td><code>1</code></td><td><code>0</code></td></tr>
<tr><td><code>1</code></td><td><code>0</code></td><td><code>0</code></td></tr>
<tr><td><code>1</code></td><td><code>1</code></td><td><code>1</code></td></tr>
</tbody>
</table>

<p>Naziv te logičke funkcije je <em>I</em> (engl. <i>AND</i>). Logička funkcija I na svojem izlazu daje vrijednost <code>1</code> samo kada je na svim ulazima postavljena logička vrijednost <code>1</code>.
U svim ostalim situacijama izlaz će biti <code>0</code>.</p>

<p>U tablici u nastavku prikazani su simboli kojima prikazujemo sklopove koji obavljaju funkciju I.</p>

<table class="mlTableCC">
<tr><td><img src="@#file#(and-iec.svg)" alt="IEC AND simbol"></td><td><img src="@#file#(and-ansi.svg)" alt="ANSI AND simbol"></td></tr>
<tr><td>Simbol prema IEC-u</td><td>Simbol prema ANSI-ju</td></tr>
</table>

<p>Primjetite oznaku koja je navedena kod IEC-simbola. Zapamtite je ovako: izlaz je jedan kad je na prvom ulazu <code>1</code> I ("&amp;") na drugom ulazu <code>1</code>.</p>

<p>Funkcija I uz uobičajenu namjenu ("daj na izlazu 1 samo kada su svi ulazi u 1") ima još jednu praktičnu primjenu koju ćemo opisati u nastavku. Pretpostavimo da želimo sklop koji se ponaša kako je specificirano na slici u nastavku.</p>

<figure style="text-align: center;">
<img src="@#file#(pustiI-hr.svg)" alt="Sklop Propusti ili blokiraj." border="0">
<figcaption>Sklop koji ulazni signal propušta ili blokira.</figcaption>
</figure>

<p>Prikazani sklop ima dva ulaza: A i Control te jedan izlaz: Y. Kada je na upravljački ulaz Control dovedena vrijednost 1, sklop na svoj izlaz propušta vrijednost koja je dovedena na ulaz A: ako je A=0 tada će i Y biti 0; ako je A=1 tada će i Y biti 1.
Ako se na upravljački ulaz Control dovede vrijednost 0, tada sklop prestaje pratiti što se događa na ulazu A te na izlazu fiksno daje vrijednost 0.</p>

<p>Ovakav sklop htjet ćemo koristiti na putu nekog signala koji je potrebno ili dalje propustiti, ili ga blokirati. Primjerice, zamislite brojilo koje broji određen niz impulsa, ali želite da to radi samo kada je to dozvoljeno. Jedna mogućnost je niz impulsa
   provesti kroz ovakav sklop pa njegov izlaz odvesti na brojilo.</p>

<p>Ovo je lijepo ilustrirano na interaktivnoj simulaciji u nastavku. Prikazana shema se sastoji od sklopa I te generatora impulsa čiji je izlaz doveden na prvi ulaz sklopa I. Vrijednost
   koja se dovodi na drugi ulaz sklopa I (naš upravljački ulaz) može se mijenjati klikom na zasivljenu pločicu. Početno, na tom je ulazu vrijednost 1 pa očekujemo da signal koji se dovodi na prvi ulaz
   prolazi izravno na izlaz sklopa. Promatrajte jedno vrijeme rad sklopa i uočite da je to slučaj. Potom klikom na zasivljenu pločicu promijenite vrijednost koja se dovodi na drugi ulaz na 0. Gledajte sada kakva
   je veza između vrijednosti koja se dovodi na prvi ulaz i vrijednosti koja se pojavljuje na izlazu: uočite da sklop više ne prati prvi ulaz već mu je izlaz zaglavljen na vrijednosti <code>0</code>.</p>

<div style="text-align: center;">
<canvas id="myCanvas" width="320" height="160" style="border: solid 1px black;"></canvas><br>
<span class="mlSimAuthor">Autor simulacije: Leon Luttenberger</span>
</div>
<script>
    @#page-include#(Gate.js)
    @#page-include#(Utility.js)
    
    var canvas = document.getElementById("myCanvas");
    var context = canvas.getContext("2d");

    var andGate = new Gate(0, 1, function (a, b) {
        return a & b;
    }, "&");

    var gateHeight = 80;
    var gateWidth = 60;

    var inputABoxSize = 50;
    var inputBBoxSize = 30;

    var lineLengthA = 100;
    var lineLengthBX = 50;
    var lineLengthBY = 40;
    var lineLengthOutput = 60;

    var inputA;
    var inputB;

    var fontSize = 16;
    context.font = fontSize + "px Arial";

    var clockTimer = 500; //timer for the clock pulse

    draw();

    function draw() {

        context.lineWidth = 1;
        context.fillStyle = "black";
        context.strokeStyle = "black";

        context.clearRect(0, 0, canvas.width, canvas.height);
        andGate.draw(context, 160, 20, gateWidth, gateHeight);

        // Draw input A

        context.moveTo(andGate.inputAConnector.x, andGate.inputAConnector.y);
        context.lineTo(andGate.inputAConnector.x - lineLengthA, andGate.inputAConnector.y);
        context.stroke();

        inputA = new Rectangle(
                andGate.inputAConnector.x - lineLengthA - inputABoxSize,
                andGate.inputAConnector.y - inputABoxSize / 2,
                inputABoxSize,
                inputABoxSize
        );
        inputA.draw(context, 3);

        context.fillText(
                andGate.getInputA(),
                inputA.x + inputA.width + 10,
                andGate.inputAConnector.y - 10
        );
        context.fillText(
                andGate.getInputA(),
                andGate.inputAConnector.x - 20,
                andGate.inputAConnector.y - 10
        );

        drawImpulseClock(inputA, 10, 15);

        // Draw input B

        var xInputB = andGate.inputBConnector.x - lineLengthBX;
        var yInputB = andGate.inputBConnector.y + lineLengthBY;

        context.moveTo(andGate.inputBConnector.x, andGate.inputBConnector.y);
        context.lineTo(xInputB, andGate.inputBConnector.y);
        context.stroke();

        context.moveTo(xInputB, andGate.inputBConnector.y);
        context.lineTo(xInputB, yInputB);
        context.stroke();

        inputB = new Rectangle(
                xInputB - inputBBoxSize / 2,
                yInputB,
                inputBBoxSize,
                inputBBoxSize
        );
        inputB.draw(context, 3);

        context.fillStyle = "gray";
        context.fillRect(inputB.x, inputB.y, inputB.width, inputB.height);
        context.fillStyle = "black";

        context.fillText(
                andGate.getInputB(),
                inputB.x + inputB.width / 2 - fontSize / 3,
                inputB.y + inputB.height / 2 + fontSize / 3,
                inputBBoxSize
        );
        context.fillText(
                andGate.getInputB(),
                andGate.inputBConnector.x - 20,
                andGate.inputBConnector.y - 10
        );

        // Draw output

        context.moveTo(andGate.outputConnector.x, andGate.outputConnector.y);
        context.lineTo(andGate.outputConnector.x + lineLengthOutput, andGate.outputConnector.y);
        context.stroke();

        context.fillText(
                andGate.getOutput(),
                andGate.outputConnector.x + lineLengthOutput + 10,
                andGate.outputConnector.y + fontSize / 3
        );
    }

    function drawImpulseClock(box, horizontalMargin, verticalMargin) {
        var graphWidth = box.width - (2 * horizontalMargin);
        var step = graphWidth / 5;

        var xStart = box.x + horizontalMargin;

        var yBottom = box.y + box.height - verticalMargin;
        var yTop = box.y + verticalMargin;

        for (var i = 0; i < 5; i++) {
            var x = xStart + (i * step);
            var y = i % 2 != 0 ? yTop : yBottom;

            context.moveTo(x, y);
            context.lineTo(x + step, y);
            context.stroke();

            if (i != 0) {
                context.moveTo(x, yBottom);
                context.lineTo(x, yTop);
                context.stroke();
            }
        }
    }

    function animate() {
        andGate.setInputA(andGate.getInputA() == 0 ? 1: 0);

        draw();

        window.setTimeout(function () {
            animate();
        }, clockTimer);
    }

    window.setTimeout(function () {
        animate();
    }, clockTimer);

    canvas.addEventListener("mousedown", function (event) {
        var mouse = getMousePos(canvas, event);

        if (inputB.containsPoint(mouse.x, mouse.y)) {
            andGate.setInputB(andGate.getInputB() == 0 ? 1: 0);
            draw();
        }
    }, true);
    
</script>

<p>Sklop I može se izravno koristiti kao sklop za upravljanje propuštanjem signala. Zamislite da ulaz B koristimo kao upravljački ulaz, i pogledajte prethodnu tablicu u kojoj je opisana funkcija I. Pogledajte najprije drugi i četvrti redak; u njima je B=<code>1</code> i izlaz f prati ulaz A. Pogledajte sada prvi i treći redak; u njima je B=<code>0</code> i izlaz f fiksiran je na vrijednost <code>0</code>.</p>
